/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.292 Revision 1.349
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.292 2007/10/14 21:55:35 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.349 2010/08/19 21:32:26 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
17 17
18inherit multilib portability 18inherit multilib portability
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then
23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
52# Default directory where patches are located 54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: eqawarn
67# @USAGE: [message]
68# @DESCRIPTION:
69# Proxy to einfo for package managers that don't provide eqawarn and use the PM
70# implementation if available.
71if ! declare -F eqawarn >/dev/null ; then
72 eqawarn() {
73 einfo "$@"
74 }
75fi
76
77# @FUNCTION: ecvs_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove CVS directories recursiveley. Useful when a source tarball contains
81# internal CVS directories. Defaults to $PWD.
82ecvs_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
85 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
86}
87
88# @FUNCTION: esvn_clean
89# @USAGE: [list of dirs]
90# @DESCRIPTION:
91# Remove .svn directories recursiveley. Useful when a source tarball contains
92# internal Subversion directories. Defaults to $PWD.
93esvn_clean() {
94 [[ -z $* ]] && set -- .
95 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
96}
97
98# @FUNCTION: eshopts_push
99# @USAGE: [options to `set` or `shopt`]
100# @DESCRIPTION:
101# Often times code will want to enable a shell option to change code behavior.
102# Since changing shell options can easily break other pieces of code (which
103# assume the default state), eshopts_push is used to (1) push the current shell
104# options onto a stack and (2) pass the specified arguments to set.
105#
106# If the first argument is '-s' or '-u', we assume you want to call `shopt`
107# rather than `set` as there are some options only available via that.
108#
109# A common example is to disable shell globbing so that special meaning/care
110# may be used with variables/arguments to custom functions. That would be:
111# @CODE
112# eshopts_push -o noglob
113# for x in ${foo} ; do
114# if ...some check... ; then
115# eshopts_pop
116# return 0
117# fi
118# done
119# eshopts_pop
120# @CODE
121eshopts_push() {
122 # have to assume __ESHOPTS_SAVE__ isn't screwed with
123 # as a `declare -a` here will reset its value
124 local i=${#__ESHOPTS_SAVE__[@]}
125 if [[ $1 == -[su] ]] ; then
126 __ESHOPTS_SAVE__[$i]=$(shopt -p)
127 [[ $# -eq 0 ]] && return 0
128 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
129 else
130 __ESHOPTS_SAVE__[$i]=$-
131 [[ $# -eq 0 ]] && return 0
132 set "$@" || die "eshopts_push: bad options to set: $*"
133 fi
134}
135
136# @FUNCTION: eshopts_pop
137# @USAGE:
138# @DESCRIPTION:
139# Restore the shell options to the state saved with the corresponding
140# eshopts_push call. See that function for more details.
141eshopts_pop() {
142 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
143 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
144 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
145 local s=${__ESHOPTS_SAVE__[$i]}
146 unset __ESHOPTS_SAVE__[$i]
147 if [[ ${s} == "shopt -"* ]] ; then
148 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
149 else
150 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
151 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
152 fi
153}
154
155# @VARIABLE: EPATCH_SOURCE
156# @DESCRIPTION:
157# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 158EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 159# @VARIABLE: EPATCH_SUFFIX
160# @DESCRIPTION:
161# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 162EPATCH_SUFFIX="patch.bz2"
163# @VARIABLE: EPATCH_OPTS
164# @DESCRIPTION:
56# Default options for patch 165# Default options for patch:
166# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 167# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 168# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 169# -E - automatically remove empty files
170# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 171EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
172# @VARIABLE: EPATCH_EXCLUDE
173# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 174# List of patches not to apply. Note this is only file names,
62# and not the full path .. 175# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 176EPATCH_EXCLUDE=""
177# @VARIABLE: EPATCH_SINGLE_MSG
178# @DESCRIPTION:
64# Change the printed message for a single patch. 179# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 180EPATCH_SINGLE_MSG=""
181# @VARIABLE: EPATCH_MULTI_MSG
182# @DESCRIPTION:
66# Change the printed message for multiple patches. 183# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 184EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 185# @VARIABLE: EPATCH_FORCE
69# 186# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 187# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 188# arch naming style.
72EPATCH_FORCE="no" 189EPATCH_FORCE="no"
73 190
74# This function is for bulk patching, or in theory for just one 191# @FUNCTION: epatch
75# or two patches. 192# @USAGE: [patches] [dirs of patches]
193# @DESCRIPTION:
194# epatch is designed to greatly simplify the application of patches. It can
195# process patch files directly, or directories of patches. The patches may be
196# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
197# the -p option as epatch will automatically attempt -p0 to -p5 until things
198# apply successfully.
76# 199#
77# It should work with .bz2, .gz, .zip and plain text patches. 200# If you do not specify any options, then epatch will default to the directory
78# Currently all patches should be the same format. 201# specified by EPATCH_SOURCE.
79# 202#
80# You do not have to specify '-p' option to patch, as it will 203# When processing directories, epatch will apply all patches that match:
81# try with -p0 to -p5 until it succeed, or fail at -p5. 204# @CODE
82# 205# ${EPATCH_FORCE} == "yes"
83# Above EPATCH_* variables can be used to control various defaults,
84# bug they should be left as is to ensure an ebuild can rely on
85# them for.
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 206# ??_${ARCH}_foo.${EPATCH_SUFFIX}
207# else
208# *.${EPATCH_SUFFIX}
209# @CODE
210# The leading ?? are typically numbers used to force consistent patch ordering.
211# The arch field is used to apply patches only for the host architecture with
212# the special value of "all" means apply for everyone. Note that using values
213# other than "all" is highly discouraged -- you should apply patches all the
214# time and let architecture details be detected at configure/compile time.
92# 215#
93# For example: 216# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
217# for patches to apply.
94# 218#
95# 01_all_misc-fix.patch.bz2 219# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 220epatch() {
108 _epatch_draw_line() { 221 _epatch_draw_line() {
222 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 223 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 224 echo "${1//?/=}"
111 } 225 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 226
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 227 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 228
122 if [ "$#" -gt 1 ] 229 # Let the rest of the code process one user arg at a time --
123 then 230 # each arg may expand into multiple patches, and each arg may
231 # need to start off with the default global EPATCH_xxx values
232 if [[ $# -gt 1 ]] ; then
124 local m="" 233 local m
125 for m in "$@" ; do 234 for m in "$@" ; do
126 epatch "${m}" 235 epatch "${m}"
127 done 236 done
128 return 0 237 return 0
129 fi 238 fi
130 239
131 if [ -n "$1" -a -f "$1" ] 240 local SINGLE_PATCH="no"
132 then 241 # no args means process ${EPATCH_SOURCE}
242 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
243
244 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 245 SINGLE_PATCH="yes"
134 246 set -- "$1"
135 local EPATCH_SOURCE="$1" 247 # Use the suffix from the single patch (localize it); the code
248 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 249 local EPATCH_SUFFIX=$1
137 250
138 elif [ -n "$1" -a -d "$1" ] 251 elif [[ -d $1 ]] ; then
139 then 252 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 253 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 254
255 else
256 # sanity check ... if it isn't a dir or file, wtf man ?
257 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
258 echo
259 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
260 eerror
261 eerror " ${EPATCH_SOURCE}"
262 eerror " ( ${EPATCH_SOURCE##*/} )"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local PIPE_CMD
268 case ${EPATCH_SUFFIX##*\.} in
269 xz) PIPE_CMD="xz -dc" ;;
270 lzma) PIPE_CMD="lzma -dc" ;;
271 bz2) PIPE_CMD="bzip2 -dc" ;;
272 gz|Z|z) PIPE_CMD="gzip -dc" ;;
273 ZIP|zip) PIPE_CMD="unzip -p" ;;
274 *) ;;
275 esac
276
277 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
278
279 local x
280 for x in "$@" ; do
281 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
282 # didn't match anything, ignore continue on
283 [[ ! -f ${x} ]] && continue
284
285 local patchname=${x##*/}
286
287 # Apply single patches, or forced sets of patches, or
288 # patches with ARCH dependant names.
289 # ???_arch_foo.patch
290 # Else, skip this input altogether
291 local a=${patchname#*_} # strip the ???_
292 a=${a%%_*} # strip the _foo.patch
293 if ! [[ ${SINGLE_PATCH} == "yes" || \
294 ${EPATCH_FORCE} == "yes" || \
295 ${a} == all || \
296 ${a} == ${ARCH} ]]
142 then 297 then
143 local EPATCH_SOURCE="$1/*" 298 continue
299 fi
300
301 # Let people filter things dynamically
302 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
303 # let people use globs in the exclude
304 eshopts_push -o noglob
305
306 local ex
307 for ex in ${EPATCH_EXCLUDE} ; do
308 if [[ ${patchname} == ${ex} ]] ; then
309 eshopts_pop
310 continue 2
311 fi
312 done
313
314 eshopts_pop
315 fi
316
317 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
318 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
319 einfo "${EPATCH_SINGLE_MSG}"
320 else
321 einfo "Applying ${patchname} ..."
322 fi
144 else 323 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 324 einfo " ${patchname} ..."
146 fi 325 fi
147 else 326
148 if [ ! -d ${EPATCH_SOURCE} ] || [ -n "$1" ] 327 # most of the time, there will only be one run per unique name,
149 then 328 # but if there are more, make sure we get unique log filenames
150 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 329 local STDERR_TARGET="${T}/${patchname}.out"
151 then 330 if [[ -e ${STDERR_TARGET} ]] ; then
152 EPATCH_SOURCE="$1" 331 STDERR_TARGET="${T}/${patchname}-$$.out"
332 fi
333
334 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
335
336 # Decompress the patch if need be
337 local count=0
338 local PATCH_TARGET
339 if [[ -n ${PIPE_CMD} ]] ; then
340 PATCH_TARGET="${T}/$$.patch"
341 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
342
343 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
344 echo
345 eerror "Could not extract patch!"
346 #die "Could not extract patch!"
347 count=5
348 break
153 fi 349 fi
350 else
351 PATCH_TARGET=${x}
352 fi
154 353
354 # Check for absolute paths in patches. If sandbox is disabled,
355 # people could (accidently) patch files in the root filesystem.
356 # Or trigger other unpleasantries #237667. So disallow -p0 on
357 # such patches.
358 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
359 if [[ -n ${abs_paths} ]] ; then
360 count=1
361 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
362 fi
363
364 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
365 while [[ ${count} -lt 5 ]] ; do
366 # Generate some useful debug info ...
367 (
368 _epatch_draw_line "***** ${patchname} *****"
155 echo 369 echo
156 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 370 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
371 echo
372 _epatch_draw_line "***** ${patchname} *****"
373 ) >> "${STDERR_TARGET}"
374
375 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
376 (
377 _epatch_draw_line "***** ${patchname} *****"
378 echo
379 echo "ACTUALLY APPLYING ${patchname} ..."
380 echo
381 _epatch_draw_line "***** ${patchname} *****"
382 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
383 ) >> "${STDERR_TARGET}"
384
385 if [ $? -ne 0 ] ; then
386 echo
387 eerror "A dry-run of patch command succeeded, but actually"
388 eerror "applying the patch failed!"
389 #die "Real world sux compared to the dreamworld!"
390 count=5
391 fi
392 break
393 fi
394
395 : $(( count++ ))
396 done
397
398 # if we had to decompress the patch, delete the temp one
399 if [[ -n ${PIPE_CMD} ]] ; then
400 rm -f "${PATCH_TARGET}"
401 fi
402
403 if [[ ${count} -ge 5 ]] ; then
404 echo
405 eerror "Failed Patch: ${patchname} !"
406 eerror " ( ${PATCH_TARGET} )"
157 eerror 407 eerror
158 eerror " ${EPATCH_SOURCE}" 408 eerror "Include in your bugreport the contents of:"
159 eerror " ( ${EPATCH_SOURCE##*/} )" 409 eerror
410 eerror " ${STDERR_TARGET}"
160 echo 411 echo
161 die "Cannot find \$EPATCH_SOURCE!"
162 fi
163
164 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
165 fi
166
167 case ${EPATCH_SUFFIX##*\.} in
168 bz2)
169 PIPE_CMD="bzip2 -dc"
170 PATCH_SUFFIX="bz2"
171 ;;
172 gz|Z|z)
173 PIPE_CMD="gzip -dc"
174 PATCH_SUFFIX="gz"
175 ;;
176 ZIP|zip)
177 PIPE_CMD="unzip -p"
178 PATCH_SUFFIX="zip"
179 ;;
180 *)
181 PIPE_CMD="cat"
182 PATCH_SUFFIX="patch"
183 ;;
184 esac
185
186 if [ "${SINGLE_PATCH}" = "no" ]
187 then
188 einfo "${EPATCH_MULTI_MSG}"
189 fi
190 for x in ${EPATCH_SOURCE}
191 do
192 # New ARCH dependant patch naming scheme ...
193 #
194 # ???_arch_foo.patch
195 #
196 if [ -f ${x} ] && \
197 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
198 [ "${EPATCH_FORCE}" = "yes" ])
199 then
200 local count=0
201 local popts="${EPATCH_OPTS}"
202 local patchname=${x##*/}
203
204 if [ -n "${EPATCH_EXCLUDE}" ]
205 then
206 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
207 then
208 continue
209 fi
210 fi
211
212 if [ "${SINGLE_PATCH}" = "yes" ]
213 then
214 if [ -n "${EPATCH_SINGLE_MSG}" ]
215 then
216 einfo "${EPATCH_SINGLE_MSG}"
217 else
218 einfo "Applying ${patchname} ..."
219 fi
220 else
221 einfo " ${patchname} ..."
222 fi
223
224 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
226
227 # Allow for prefix to differ ... im lazy, so shoot me :/
228 while [ "${count}" -lt 5 ]
229 do
230 # Generate some useful debug info ...
231 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
233
234 if [ "${PATCH_SUFFIX}" != "patch" ]
235 then
236 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
238 else
239 PATCH_TARGET="${x}"
240 fi
241
242 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
244
245 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
247
248 if [ "${PATCH_SUFFIX}" != "patch" ]
249 then
250 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
251 then
252 echo
253 eerror "Could not extract patch!"
254 #die "Could not extract patch!"
255 count=5
256 break
257 fi
258 fi
259
260 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
261 then
262 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
267
268 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
269 _epatch_assert
270
271 if [ "$?" -ne 0 ]
272 then
273 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
274 echo
275 eerror "A dry-run of patch command succeeded, but actually"
276 eerror "applying the patch failed!"
277 #die "Real world sux compared to the dreamworld!"
278 count=5
279 fi
280
281 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
282
283 break
284 fi
285
286 count=$((count + 1))
287 done
288
289 if [ "${PATCH_SUFFIX}" != "patch" ]
290 then
291 rm -f ${PATCH_TARGET}
292 fi
293
294 if [ "${count}" -eq 5 ]
295 then
296 echo
297 eerror "Failed Patch: ${patchname} !"
298 eerror " ( ${PATCH_TARGET} )"
299 eerror
300 eerror "Include in your bugreport the contents of:"
301 eerror
302 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
303 echo
304 die "Failed Patch: ${patchname}!" 412 die "Failed Patch: ${patchname}!"
305 fi 413 fi
306 414
307 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 415 # if everything worked, delete the patch log
308 416 rm -f "${STDERR_TARGET}"
309 eend 0 417 eend 0
310 fi
311 done 418 done
312 if [ "${SINGLE_PATCH}" = "no" ] 419
313 then 420 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
314 einfo "Done with patching" 421 : # everything worked
422}
423epatch_user() {
424 [[ $# -ne 0 ]] && die "epatch_user takes no options"
425
426 # don't clobber any EPATCH vars that the parent might want
427 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
428 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
429 EPATCH_SOURCE=${base}/${CTARGET}/${check}
430 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
431 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
432 if [[ -d ${EPATCH_SOURCE} ]] ; then
433 EPATCH_SOURCE=${EPATCH_SOURCE} \
434 EPATCH_SUFFIX="patch" \
435 EPATCH_FORCE="yes" \
436 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
437 epatch
438 return 0
315 fi 439 fi
440 done
441 return 1
316} 442}
317 443
318# @FUNCTION: emktemp 444# @FUNCTION: emktemp
319# @USAGE: [temp dir] 445# @USAGE: [temp dir]
320# @DESCRIPTION: 446# @DESCRIPTION:
356# base-system@gentoo.org (Linux) 482# base-system@gentoo.org (Linux)
357# Joe Jezak <josejx@gmail.com> (OS X) 483# Joe Jezak <josejx@gmail.com> (OS X)
358# usata@gentoo.org (OS X) 484# usata@gentoo.org (OS X)
359# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD) 485# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
360# @DESCRIPTION: 486# @DESCRIPTION:
361# Small wrapper for getent (Linux), nidump (Mac OS X), 487# Small wrapper for getent (Linux),
488# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
362# and pw (FreeBSD) used in enewuser()/enewgroup() 489# and pw (FreeBSD) used in enewuser()/enewgroup()
363egetent() { 490egetent() {
364 case ${CHOST} in 491 case ${CHOST} in
365 *-darwin*) 492 *-darwin[678])
366 case "$2" in 493 case "$2" in
367 *[!0-9]*) # Non numeric 494 *[!0-9]*) # Non numeric
368 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 495 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
369 ;; 496 ;;
370 *) # Numeric 497 *) # Numeric
371 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 498 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
499 ;;
500 esac
501 ;;
502 *-darwin*)
503 local mytype=$1
504 [[ "passwd" == $mytype ]] && mytype="Users"
505 [[ "group" == $mytype ]] && mytype="Groups"
506 case "$2" in
507 *[!0-9]*) # Non numeric
508 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
509 ;;
510 *) # Numeric
511 local mykey="UniqueID"
512 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
513 dscl . -search /$mytype $mykey $2 2>/dev/null
372 ;; 514 ;;
373 esac 515 esac
374 ;; 516 ;;
375 *-freebsd*|*-dragonfly*) 517 *-freebsd*|*-dragonfly*)
376 local opts action="user" 518 local opts action="user"
576 fi 718 fi
577 ;; 719 ;;
578 720
579 *) 721 *)
580 if [[ -z $@ ]] ; then 722 if [[ -z $@ ]] ; then
581 useradd ${opts} ${euser} \ 723 useradd -r ${opts} \
582 -c "added by portage for ${PN}" \ 724 -c "added by portage for ${PN}" \
725 ${euser} \
583 || die "enewuser failed" 726 || die "enewuser failed"
584 else 727 else
585 einfo " - Extra: $@" 728 einfo " - Extra: $@"
586 useradd ${opts} ${euser} "$@" \ 729 useradd -r ${opts} "$@" \
730 ${euser} \
587 || die "enewuser failed" 731 || die "enewuser failed"
588 fi 732 fi
589 ;; 733 ;;
590 esac 734 esac
591 735
703 esac 847 esac
704 groupadd -g ${egid} ${egroup} || die "enewgroup failed" 848 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
705 ;; 849 ;;
706 850
707 *) 851 *)
852 # We specify -r so that we get a GID in the system range from login.defs
708 groupadd ${opts} ${egroup} || die "enewgroup failed" 853 groupadd -r ${opts} ${egroup} || die "enewgroup failed"
709 ;; 854 ;;
710 esac 855 esac
711 export SANDBOX_ON="${oldsandbox}" 856 export SANDBOX_ON="${oldsandbox}"
712} 857}
713 858
724 869
725# Make a desktop file ! 870# Make a desktop file !
726# Great for making those icons in kde/gnome startmenu ! 871# Great for making those icons in kde/gnome startmenu !
727# Amaze your friends ! Get the women ! Join today ! 872# Amaze your friends ! Get the women ! Join today !
728# 873#
729# make_desktop_entry(<command>, [name], [icon], [type], [path]) 874# make_desktop_entry(<command>, [name], [icon], [type], [fields])
730# 875#
731# binary: what command does the app run with ? 876# binary: what command does the app run with ?
732# name: the name that will show up in the menu 877# name: the name that will show up in the menu
733# icon: give your little like a pretty little icon ... 878# icon: give your little like a pretty little icon ...
734# this can be relative (to /usr/share/pixmaps) or 879# this can be relative (to /usr/share/pixmaps) or
735# a full path to an icon 880# a full path to an icon
736# type: what kind of application is this ? for categories: 881# type: what kind of application is this ? for categories:
737# http://standards.freedesktop.org/menu-spec/latest/apa.html 882# http://standards.freedesktop.org/menu-spec/latest/apa.html
738# path: if your app needs to startup in a specific dir 883# fields: extra fields to append to the desktop file; a printf string
739make_desktop_entry() { 884make_desktop_entry() {
740 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 885 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
741 886
742 local exec=${1} 887 local exec=${1}
743 local name=${2:-${PN}} 888 local name=${2:-${PN}}
744 local icon=${3:-${PN}.png} 889 local icon=${3:-${PN}}
745 local type=${4} 890 local type=${4}
746 local path=${5} 891 local fields=${5}
747 892
748 if [[ -z ${type} ]] ; then 893 if [[ -z ${type} ]] ; then
749 local catmaj=${CATEGORY%%-*} 894 local catmaj=${CATEGORY%%-*}
750 local catmin=${CATEGORY##*-} 895 local catmin=${CATEGORY##*-}
751 case ${catmaj} in 896 case ${catmaj} in
752 app) 897 app)
753 case ${catmin} in 898 case ${catmin} in
754 accessibility) type=Accessibility;; 899 accessibility) type=Accessibility;;
755 admin) type=System;; 900 admin) type=System;;
756 antivirus) type=System;; 901 antivirus) type=System;;
757 arch) type=Archiving;; 902 arch) type=Archiving;;
758 backup) type=Archiving;; 903 backup) type=Archiving;;
759 cdr) type=DiscBurning;; 904 cdr) type=DiscBurning;;
760 dicts) type=Dictionary;; 905 dicts) type=Dictionary;;
761 doc) type=Documentation;; 906 doc) type=Documentation;;
762 editors) type=TextEditor;; 907 editors) type=TextEditor;;
763 emacs) type=TextEditor;; 908 emacs) type=TextEditor;;
764 emulation) type=Emulator;; 909 emulation) type=Emulator;;
765 laptop) type=HardwareSettings;; 910 laptop) type=HardwareSettings;;
766 office) type=Office;; 911 office) type=Office;;
767 pda) type=PDA;; 912 pda) type=PDA;;
768 vim) type=TextEditor;; 913 vim) type=TextEditor;;
769 xemacs) type=TextEditor;; 914 xemacs) type=TextEditor;;
770 *) type=;;
771 esac 915 esac
772 ;; 916 ;;
773 917
774 dev) 918 dev)
775 type="Development" 919 type="Development"
776 ;; 920 ;;
777 921
778 games) 922 games)
779 case ${catmin} in 923 case ${catmin} in
780 action|fps) type=ActionGame;; 924 action|fps) type=ActionGame;;
781 arcade) type=ArcadeGame;; 925 arcade) type=ArcadeGame;;
782 board) type=BoardGame;; 926 board) type=BoardGame;;
783 emulation) type=Emulator;; 927 emulation) type=Emulator;;
784 kids) type=KidsGame;; 928 kids) type=KidsGame;;
785 puzzle) type=LogicGame;; 929 puzzle) type=LogicGame;;
786 roguelike) type=RolePlaying;; 930 roguelike) type=RolePlaying;;
787 rpg) type=RolePlaying;; 931 rpg) type=RolePlaying;;
788 simulation) type=Simulation;; 932 simulation) type=Simulation;;
789 sports) type=SportsGame;; 933 sports) type=SportsGame;;
790 strategy) type=StrategyGame;; 934 strategy) type=StrategyGame;;
791 *) type=;;
792 esac 935 esac
793 type="Game;${type}" 936 type="Game;${type}"
794 ;; 937 ;;
795 938
796 gnome) 939 gnome)
805 type="Network;Email" 948 type="Network;Email"
806 ;; 949 ;;
807 950
808 media) 951 media)
809 case ${catmin} in 952 case ${catmin} in
953 gfx)
810 gfx) type=Graphics;; 954 type=Graphics
955 ;;
956 *)
957 case ${catmin} in
811 radio) type=Tuner;; 958 radio) type=Tuner;;
812 sound) type=Audio;; 959 sound) type=Audio;;
813 tv) type=TV;; 960 tv) type=TV;;
814 video) type=Video;; 961 video) type=Video;;
815 *) type=;; 962 esac
963 type="AudioVideo;${type}"
964 ;;
816 esac 965 esac
817 type="AudioVideo;${type}"
818 ;; 966 ;;
819 967
820 net) 968 net)
821 case ${catmin} in 969 case ${catmin} in
822 dialup) type=Dialup;; 970 dialup) type=Dialup;;
823 ftp) type=FileTransfer;; 971 ftp) type=FileTransfer;;
824 im) type=InstantMessaging;; 972 im) type=InstantMessaging;;
825 irc) type=IRCClient;; 973 irc) type=IRCClient;;
826 mail) type=Email;; 974 mail) type=Email;;
827 news) type=News;; 975 news) type=News;;
828 nntp) type=News;; 976 nntp) type=News;;
829 p2p) type=FileTransfer;; 977 p2p) type=FileTransfer;;
830 *) type=;; 978 voip) type=Telephony;;
831 esac 979 esac
832 type="Network;${type}" 980 type="Network;${type}"
833 ;; 981 ;;
834 982
835 sci) 983 sci)
836 case ${catmin} in 984 case ${catmin} in
837 astro*) type=Astronomy;; 985 astro*) type=Astronomy;;
838 bio*) type=Biology;; 986 bio*) type=Biology;;
839 calc*) type=Calculator;; 987 calc*) type=Calculator;;
840 chem*) type=Chemistry;; 988 chem*) type=Chemistry;;
841 elec*) type=Electronics;; 989 elec*) type=Electronics;;
842 geo*) type=Geology;; 990 geo*) type=Geology;;
843 math*) type=Math;; 991 math*) type=Math;;
844 physics) type=Physics;; 992 physics) type=Physics;;
845 visual*) type=DataVisualization;; 993 visual*) type=DataVisualization;;
846 *) type=;;
847 esac 994 esac
848 type="Science;${type}" 995 type="Education;Science;${type}"
849 ;; 996 ;;
850 997
851 sys) 998 sys)
852 type="System" 999 type="System"
853 ;; 1000 ;;
854 1001
855 www) 1002 www)
856 case ${catmin} in 1003 case ${catmin} in
857 client) type=WebBrowser;; 1004 client) type=WebBrowser;;
858 *) type=;;
859 esac 1005 esac
860 type="Network" 1006 type="Network;${type}"
861 ;; 1007 ;;
862 1008
863 *) 1009 *)
864 type= 1010 type=
865 ;; 1011 ;;
871 local desktop_name="${PN}-${SLOT}" 1017 local desktop_name="${PN}-${SLOT}"
872 fi 1018 fi
873 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1019 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
874 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1020 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
875 1021
1022 # Don't append another ";" when a valid category value is provided.
1023 type=${type%;}${type:+;}
1024
1025 eshopts_push -s extglob
1026 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1027 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1028 ewarn "allowed in .desktop files if the value is not an absolute path."
1029 icon=${icon%.@(xpm|png|svg)}
1030 fi
1031 eshopts_pop
1032
876 cat <<-EOF > "${desktop}" 1033 cat <<-EOF > "${desktop}"
877 [Desktop Entry] 1034 [Desktop Entry]
878 Encoding=UTF-8
879 Version=1.0
880 Name=${name} 1035 Name=${name}
881 Type=Application 1036 Type=Application
882 Comment=${DESCRIPTION} 1037 Comment=${DESCRIPTION}
883 Exec=${exec} 1038 Exec=${exec}
884 TryExec=${exec%% *} 1039 TryExec=${exec%% *}
885 Path=${path}
886 Icon=${icon} 1040 Icon=${icon}
887 Categories=${type}; 1041 Categories=${type}
888 EOF 1042 EOF
1043
1044 if [[ ${fields:-=} != *=* ]] ; then
1045 # 5th arg used to be value to Path=
1046 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1047 fields="Path=${fields}"
1048 fi
1049 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
889 1050
890 ( 1051 (
891 # wrap the env here so that the 'insinto' call 1052 # wrap the env here so that the 'insinto' call
892 # doesn't corrupt the env of the caller 1053 # doesn't corrupt the env of the caller
893 insinto /usr/share/applications 1054 insinto /usr/share/applications
894 doins "${desktop}" 1055 doins "${desktop}"
895 ) 1056 ) || die "installing desktop file failed"
896} 1057}
897 1058
898# @FUNCTION: validate_desktop_entries 1059# @FUNCTION: validate_desktop_entries
899# @USAGE: [directories] 1060# @USAGE: [directories]
900# @MAINTAINER: 1061# @MAINTAINER:
922 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 1083 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
923 fi 1084 fi
924} 1085}
925 1086
926# @FUNCTION: make_session_desktop 1087# @FUNCTION: make_session_desktop
927# @USAGE: <title> <command> 1088# @USAGE: <title> <command> [command args...]
928# @DESCRIPTION: 1089# @DESCRIPTION:
929# Make a GDM/KDM Session file. The title is the file to execute to start the 1090# Make a GDM/KDM Session file. The title is the file to execute to start the
930# Window Manager. The command is the name of the Window Manager. 1091# Window Manager. The command is the name of the Window Manager.
1092#
1093# You can set the name of the file via the ${wm} variable.
931make_session_desktop() { 1094make_session_desktop() {
932 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1095 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
933 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1096 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
934 1097
935 local title=$1 1098 local title=$1
936 local command=$2 1099 local command=$2
937 local desktop=${T}/${wm}.desktop 1100 local desktop=${T}/${wm:-${PN}}.desktop
1101 shift 2
938 1102
939 cat <<-EOF > "${desktop}" 1103 cat <<-EOF > "${desktop}"
940 [Desktop Entry] 1104 [Desktop Entry]
941 Encoding=UTF-8
942 Name=${title} 1105 Name=${title}
943 Comment=This session logs you into ${title} 1106 Comment=This session logs you into ${title}
944 Exec=${command} 1107 Exec=${command} $*
945 TryExec=${command} 1108 TryExec=${command}
946 Type=Application 1109 Type=XSession
947 EOF 1110 EOF
948 1111
949 ( 1112 (
950 # wrap the env here so that the 'insinto' call 1113 # wrap the env here so that the 'insinto' call
951 # doesn't corrupt the env of the caller 1114 # doesn't corrupt the env of the caller
1177 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'" 1340 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1178 1341
1179 local shrtsrc=$(basename "${src}") 1342 local shrtsrc=$(basename "${src}")
1180 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1343 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1181 if [[ -z ${skip} ]] ; then 1344 if [[ -z ${skip} ]] ; then
1182 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}') 1345 local ver=$(grep -m1 -a '#.*Makeself' "${src}" | awk '{print $NF}')
1183 local skip=0 1346 local skip=0
1184 exe=tail 1347 exe=tail
1185 case ${ver} in 1348 case ${ver} in
1186 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1349 1.5.*|1.6.0-nv) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1187 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1350 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1189 2.0|2.0.1) 1352 2.0|2.0.1)
1190 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-) 1353 skip=$(grep -a ^$'\t'tail "${src}" | awk '{print $2}' | cut -b2-)
1191 ;; 1354 ;;
1192 2.1.1) 1355 2.1.1)
1193 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-) 1356 skip=$(grep -a ^offset= "${src}" | awk '{print $2}' | cut -b2-)
1194 let skip="skip + 1" 1357 (( skip++ ))
1195 ;; 1358 ;;
1196 2.1.2) 1359 2.1.2)
1197 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1) 1360 skip=$(grep -a ^offset= "${src}" | awk '{print $3}' | head -n 1)
1198 let skip="skip + 1" 1361 (( skip++ ))
1199 ;; 1362 ;;
1200 2.1.3) 1363 2.1.3)
1201 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1364 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1202 let skip="skip + 1" 1365 (( skip++ ))
1203 ;; 1366 ;;
1204 2.1.4|2.1.5) 1367 2.1.4|2.1.5)
1205 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1368 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1206 skip=$(head -n ${skip} "${src}" | wc -c) 1369 skip=$(head -n ${skip} "${src}" | wc -c)
1207 exe="dd" 1370 exe="dd"
1216 esac 1379 esac
1217 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset" 1380 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1218 fi 1381 fi
1219 case ${exe} in 1382 case ${exe} in
1220 tail) exe="tail -n +${skip} '${src}'";; 1383 tail) exe="tail -n +${skip} '${src}'";;
1221 dd) exe="dd ibs=${skip} skip=1 obs=1024 conv=sync if='${src}'";; 1384 dd) exe="dd ibs=${skip} skip=1 if='${src}'";;
1222 *) die "makeself cant handle exe '${exe}'" 1385 *) die "makeself cant handle exe '${exe}'"
1223 esac 1386 esac
1224 1387
1225 # lets grab the first few bytes of the file to figure out what kind of archive it is 1388 # lets grab the first few bytes of the file to figure out what kind of archive it is
1226 local tmpfile=$(emktemp) 1389 local tmpfile=$(emktemp)
1263 lic="${PWD}/${lic}" 1426 lic="${PWD}/${lic}"
1264 elif [ -e "${lic}" ] ; then 1427 elif [ -e "${lic}" ] ; then
1265 lic="${lic}" 1428 lic="${lic}"
1266 fi 1429 fi
1267 fi 1430 fi
1268 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1269 local l="`basename ${lic}`" 1431 local l="`basename ${lic}`"
1270 1432
1271 # here is where we check for the licenses the user already 1433 # here is where we check for the licenses the user already
1272 # accepted ... if we don't find a match, we make the user accept 1434 # accepted ... if we don't find a match, we make the user accept
1273 local shopts=$-
1274 local alic 1435 local alic
1275 set -o noglob #so that bash doesn't expand "*" 1436 eshopts_push -o noglob # so that bash doesn't expand "*"
1276 for alic in ${ACCEPT_LICENSE} ; do 1437 for alic in ${ACCEPT_LICENSE} ; do
1277 if [[ ${alic} == ${l} ]]; then 1438 if [[ ${alic} == ${l} ]]; then
1278 set +o noglob; set -${shopts} #reset old shell opts 1439 eshopts_pop
1279 return 0 1440 return 0
1280 fi 1441 fi
1281 done 1442 done
1282 set +o noglob; set -$shopts #reset old shell opts 1443 eshopts_pop
1444 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1283 1445
1284 local licmsg=$(emktemp) 1446 local licmsg=$(emktemp)
1285 cat <<-EOF > ${licmsg} 1447 cat <<-EOF > ${licmsg}
1286 ********************************************************** 1448 **********************************************************
1287 The following license outlines the terms of use of this 1449 The following license outlines the terms of use of this
1360 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}} 1522 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1361 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1523 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1362 export CDROM_SET=-1 1524 export CDROM_SET=-1
1363 for f in ${CDROM_CHECK_1//:/ } ; do 1525 for f in ${CDROM_CHECK_1//:/ } ; do
1364 ((++CDROM_SET)) 1526 ((++CDROM_SET))
1365 [[ -e ${CD_ROOT}/${f} ]] && break 1527 [[ -e ${CDROM_ROOT}/${f} ]] && break
1366 done 1528 done
1367 export CDROM_MATCH=${f} 1529 export CDROM_MATCH=${f}
1368 return 1530 return
1369 fi 1531 fi
1370 1532
1456# displayed and we'll hang out here until: 1618# displayed and we'll hang out here until:
1457# (1) the file is found on a mounted cdrom 1619# (1) the file is found on a mounted cdrom
1458# (2) the user hits CTRL+C 1620# (2) the user hits CTRL+C
1459_cdrom_locate_file_on_cd() { 1621_cdrom_locate_file_on_cd() {
1460 local mline="" 1622 local mline=""
1461 local showedmsg=0 1623 local showedmsg=0 showjolietmsg=0
1462 1624
1463 while [[ -z ${CDROM_ROOT} ]] ; do 1625 while [[ -z ${CDROM_ROOT} ]] ; do
1464 local i=0 1626 local i=0
1465 local -a cdset=(${*//:/ }) 1627 local -a cdset=(${*//:/ })
1466 if [[ -n ${CDROM_SET} ]] ; then 1628 if [[ -n ${CDROM_SET} ]] ; then
1507 showedmsg=1 1669 showedmsg=1
1508 fi 1670 fi
1509 einfo "Press return to scan for the cd again" 1671 einfo "Press return to scan for the cd again"
1510 einfo "or hit CTRL+C to abort the emerge." 1672 einfo "or hit CTRL+C to abort the emerge."
1511 echo 1673 echo
1674 if [[ ${showjolietmsg} -eq 0 ]] ; then
1675 showjolietmsg=1
1676 else
1512 einfo "If you are having trouble with the detection" 1677 ewarn "If you are having trouble with the detection"
1513 einfo "of your CD, it is possible that you do not have" 1678 ewarn "of your CD, it is possible that you do not have"
1514 einfo "Joliet support enabled in your kernel. Please" 1679 ewarn "Joliet support enabled in your kernel. Please"
1515 einfo "check that CONFIG_JOLIET is enabled in your kernel." 1680 ewarn "check that CONFIG_JOLIET is enabled in your kernel."
1681 ebeep 5
1682 fi
1516 read || die "something is screwed with your system" 1683 read || die "something is screwed with your system"
1517 done 1684 done
1518} 1685}
1519 1686
1520# @FUNCTION: strip-linguas 1687# @FUNCTION: strip-linguas
1529# of the lists. 1696# of the lists.
1530strip-linguas() { 1697strip-linguas() {
1531 local ls newls nols 1698 local ls newls nols
1532 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1699 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1533 local op=$1; shift 1700 local op=$1; shift
1534 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1701 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1535 local d f 1702 local d f
1536 for d in "$@" ; do 1703 for d in "$@" ; do
1537 if [[ ${op} == "-u" ]] ; then 1704 if [[ ${op} == "-u" ]] ; then
1538 newls=${ls} 1705 newls=${ls}
1539 else 1706 else
1540 newls="" 1707 newls=""
1541 fi 1708 fi
1542 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1709 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1543 if [[ ${op} == "-i" ]] ; then 1710 if [[ ${op} == "-i" ]] ; then
1544 hasq ${f} ${ls} && newls="${newls} ${f}" 1711 hasq ${f} ${ls} && newls="${newls} ${f}"
1545 else 1712 else
1546 hasq ${f} ${ls} || newls="${newls} ${f}" 1713 hasq ${f} ${ls} || newls="${newls} ${f}"
1547 fi 1714 fi
1560 else 1727 else
1561 nols="${nols} ${f}" 1728 nols="${nols} ${f}"
1562 fi 1729 fi
1563 done 1730 done
1564 [[ -n ${nols} ]] \ 1731 [[ -n ${nols} ]] \
1565 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1732 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1566 export LINGUAS=${newls:1} 1733 export LINGUAS=${newls:1}
1567} 1734}
1568 1735
1569# @FUNCTION: preserve_old_lib 1736# @FUNCTION: preserve_old_lib
1570# @USAGE: <libs to preserve> [more libs] 1737# @USAGE: <libs to preserve> [more libs]
1580 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1747 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1581 die "Invalid preserve_old_lib() usage" 1748 die "Invalid preserve_old_lib() usage"
1582 fi 1749 fi
1583 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1750 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1584 1751
1752 # let portage worry about it
1753 has preserve-libs ${FEATURES} && return 0
1754
1585 local lib dir 1755 local lib dir
1586 for lib in "$@" ; do 1756 for lib in "$@" ; do
1587 [[ -e ${ROOT}/${lib} ]] || continue 1757 [[ -e ${ROOT}/${lib} ]] || continue
1588 dir=${lib%/*} 1758 dir=${lib%/*}
1589 dodir ${dir} || die "dodir ${dir} failed" 1759 dodir ${dir} || die "dodir ${dir} failed"
1599preserve_old_lib_notify() { 1769preserve_old_lib_notify() {
1600 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1770 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1601 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1771 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1602 die "Invalid preserve_old_lib_notify() usage" 1772 die "Invalid preserve_old_lib_notify() usage"
1603 fi 1773 fi
1774
1775 # let portage worry about it
1776 has preserve-libs ${FEATURES} && return 0
1604 1777
1605 local lib notice=0 1778 local lib notice=0
1606 for lib in "$@" ; do 1779 for lib in "$@" ; do
1607 [[ -e ${ROOT}/${lib} ]] || continue 1780 [[ -e ${ROOT}/${lib} ]] || continue
1608 if [[ ${notice} -eq 0 ]] ; then 1781 if [[ ${notice} -eq 0 ]] ; then
1617 ewarn " # revdep-rebuild --library ${lib##*/}" 1790 ewarn " # revdep-rebuild --library ${lib##*/}"
1618 done 1791 done
1619 if [[ ${notice} -eq 1 ]] ; then 1792 if [[ ${notice} -eq 1 ]] ; then
1620 ewarn 1793 ewarn
1621 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1794 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1622 ewarn "delete the old libraries." 1795 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1796 for lib in "$@" ; do
1797 ewarn " # rm '${lib}'"
1798 done
1623 fi 1799 fi
1624} 1800}
1625 1801
1626# @FUNCTION: built_with_use 1802# @FUNCTION: built_with_use
1627# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1803# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1628# @DESCRIPTION: 1804# @DESCRIPTION:
1805#
1806# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1807#
1629# A temporary hack until portage properly supports DEPENDing on USE 1808# A temporary hack until portage properly supports DEPENDing on USE
1630# flags being enabled in packages. This will check to see if the specified 1809# flags being enabled in packages. This will check to see if the specified
1631# DEPEND atom was built with the specified list of USE flags. The 1810# DEPEND atom was built with the specified list of USE flags. The
1632# --missing option controls the behavior if called on a package that does 1811# --missing option controls the behavior if called on a package that does
1633# not actually support the defined USE flags (aka listed in IUSE). 1812# not actually support the defined USE flags (aka listed in IUSE).
1634# The default is to abort (call die). The -a and -o flags control 1813# The default is to abort (call die). The -a and -o flags control
1635# the requirements of the USE flags. They correspond to "and" and "or" 1814# the requirements of the USE flags. They correspond to "and" and "or"
1636# logic. So the -a flag means all listed USE flags must be enabled 1815# logic. So the -a flag means all listed USE flags must be enabled
1637# while the -o flag means at least one of the listed fIUSE flags must be 1816# while the -o flag means at least one of the listed IUSE flags must be
1638# enabled. The --hidden option is really for internal use only as it 1817# enabled. The --hidden option is really for internal use only as it
1639# means the USE flag we're checking is hidden expanded, so it won't be found 1818# means the USE flag we're checking is hidden expanded, so it won't be found
1640# in IUSE like normal USE flags. 1819# in IUSE like normal USE flags.
1641# 1820#
1642# Remember that this function isn't terribly intelligent so order of optional 1821# Remember that this function isn't terribly intelligent so order of optional
1677 die) die "Unable to determine what USE flags $PKG was built with";; 1856 die) die "Unable to determine what USE flags $PKG was built with";;
1678 esac 1857 esac
1679 fi 1858 fi
1680 1859
1681 if [[ ${hidden} == "no" ]] ; then 1860 if [[ ${hidden} == "no" ]] ; then
1682 local IUSE_BUILT=$(<${IUSEFILE}) 1861 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1683 # Don't check USE_EXPAND #147237 1862 # Don't check USE_EXPAND #147237
1684 local expand 1863 local expand
1685 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1864 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1686 if [[ $1 == ${expand}_* ]] ; then 1865 if [[ $1 == ${expand}_* ]] ; then
1687 expand="" 1866 expand=""
1688 break 1867 break
1689 fi 1868 fi
1690 done 1869 done
1691 if [[ -n ${expand} ]] ; then 1870 if [[ -n ${expand} ]] ; then
1692 if ! has $1 ${IUSE_BUILT} ; then 1871 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1693 case ${missing_action} in 1872 case ${missing_action} in
1694 true) return 0;; 1873 true) return 0;;
1695 false) return 1;; 1874 false) return 1;;
1696 die) die "$PKG does not actually support the $1 USE flag!";; 1875 die) die "$PKG does not actually support the $1 USE flag!";;
1697 esac 1876 esac
1721epunt_cxx() { 1900epunt_cxx() {
1722 local dir=$1 1901 local dir=$1
1723 [[ -z ${dir} ]] && dir=${S} 1902 [[ -z ${dir} ]] && dir=${S}
1724 ebegin "Removing useless C++ checks" 1903 ebegin "Removing useless C++ checks"
1725 local f 1904 local f
1726 for f in $(find ${dir} -name configure) ; do 1905 find "${dir}" -name configure | while read f ; do
1727 patch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null 1906 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1728 done 1907 done
1729 eend 0 1908 eend 0
1730} 1909}
1731 1910
1732# @FUNCTION: make_wrapper 1911# @FUNCTION: make_wrapper
1733# @USAGE: <wrapper> <target> <chdir> [libpaths] [installpath] 1912# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1734# @DESCRIPTION: 1913# @DESCRIPTION:
1735# Create a shell wrapper script named wrapper in installpath 1914# Create a shell wrapper script named wrapper in installpath
1736# (defaults to the bindir) to execute target (default of wrapper) by 1915# (defaults to the bindir) to execute target (default of wrapper) by
1737# first optionally setting LD_LIBRARY_PATH to the colon-delimited 1916# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1738# libpaths followed by optionally changing directory to chdir. 1917# libpaths followed by optionally changing directory to chdir.
1761 ) || die 1940 ) || die
1762 else 1941 else
1763 newbin "${tmpwrapper}" "${wrapper}" || die 1942 newbin "${tmpwrapper}" "${wrapper}" || die
1764 fi 1943 fi
1765} 1944}
1945
1946# @FUNCTION: prepalldocs
1947# @USAGE:
1948# @DESCRIPTION:
1949# Compress files in /usr/share/doc which are not already
1950# compressed, excluding /usr/share/doc/${PF}/html.
1951# Uses the ecompressdir to do the compression.
1952# 2009-02-18 by betelgeuse:
1953# Commented because ecompressdir is even more internal to
1954# Portage than prepalldocs (it's not even mentioned in man 5
1955# ebuild). Please submit a better version for review to gentoo-dev
1956# if you want prepalldocs here.
1957#prepalldocs() {
1958# if [[ -n $1 ]] ; then
1959# ewarn "prepalldocs: invalid usage; takes no arguments"
1960# fi
1961
1962# cd "${D}"
1963# [[ -d usr/share/doc ]] || return 0
1964
1965# find usr/share/doc -exec gzip {} +
1966# ecompressdir --ignore /usr/share/doc/${PF}/html
1967# ecompressdir --queue /usr/share/doc
1968#}

Legend:
Removed from v.1.292  
changed lines
  Added in v.1.349

  ViewVC Help
Powered by ViewVC 1.1.20